import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowStateListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class EnablerLite
{
  static JFrame frame=null; 
  static JLabel clock=new JLabel();
  static JLabel temperature=new JLabel();
  static JLabel weatherLabel=new JLabel();      
  static JTextField command=new JTextField();
  static updateThread uThread;
  static HashMap directories=new HashMap();
  static String zip;
  static String inputText;
  
public static void main(String[] args) 
{       
    ReadSettings();
    
    //create frame
    frame = new JFrame("Enabler");

     uThread=new updateThread(frame,zip,clock, temperature, weatherLabel);
   
    //create panel
    JPanel mainPanel = new JPanel();
    mainPanel.setLayout(new GridLayout(0, 1));
   
        
    //add components to panel
    mainPanel.add(clock);
    mainPanel.add(temperature);
    mainPanel.add(weatherLabel);
    mainPanel.add(command);    
    
    //add panel to frame
    frame.getContentPane().add(mainPanel, BorderLayout.CENTER);

    //frame set up
    frame.pack();
    frame.setVisible(true);
	
    command.addActionListener(new ActionListener() 
    {
            public void actionPerformed(ActionEvent e) 
            {
                inputText = command.getText();
                Launch(inputText);
                command.setText("");
            }
    });
    
     uThread.run();
	     
    //closing stuff
    frame.addWindowListener(new WindowAdapter() 
    {
        public void windowClosing(WindowEvent e) 
            {
                System.exit(0);
            }
        });
     } 

     public static void Launch(String commandS)
     {
         int stop=commandS.length()-1;
         String file;
        for(int i=0;i<stop;i+=2)
        {
             file=commandS.substring(i,i+2);             
             try {Process p = Runtime.getRuntime().exec("\""+directories.get(file)+"\"");} 
             catch (IOException ex) {ex.printStackTrace();}
        }
        return;
     }
     
     public static void ReadSettings()
     {
         File tFile=new File("settings.txt");
	 FileInputStream fis=null;
	  		
	  try{fis = new FileInputStream(tFile);} 
	  catch (FileNotFoundException e1) {e1.printStackTrace();}
	  		 
          BufferedReader inputStream= new BufferedReader(new InputStreamReader(fis));

          String line;
          String file,directory;
          try 
          {
              zip=inputStream.readLine();
              
              while((line=inputStream.readLine()) != null)
              {
                    file=line.substring(0,2);
                    directory=line.substring(3,line.length());
                    directories.put(file,directory);
              }
          } 
          catch (IOException ex) {ex.printStackTrace();}
     }
}


		
