import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Calendar;
import javax.swing.JFrame;
import javax.swing.JLabel;    
import javax.swing.ImageIcon;

public class updateThread extends Thread 
{
    //labels
    static JLabel clockL;
    static JLabel tempL;
    static JLabel weatherL;
    
    static Calendar rightNow;
    static JFrame frame;
    
    static String zip;
    static String tString;
    
    static byte[] bytes1=new byte[23];
    static byte[] bytes2=new byte[2500];
    static URL url=null;
    static InputStream stream=null;
    static int codeStart,tempStart,codeEnd,tempEnd;
    static String code,temp;
    
    updateThread(JFrame inFrame, String inZip,JLabel clockLabel, JLabel tempLabel, JLabel weatherLabel) 
    {
        frame=inFrame;
        zip=inZip;
        clockL=clockLabel;
        tempL=tempLabel;
        weatherL=weatherLabel;
          
        try {url=new URL("http://weather.yahooapis.com/forecastrss?p="+zip);} 
        catch (MalformedURLException ex){}
    }
    
    public void run() 
    {
        while(true)
        {
            if(frame.getState()!=frame.ICONIFIED)
            {
                rightNow= Calendar.getInstance();

                if(rightNow.get(Calendar.HOUR_OF_DAY)>12)
                {
                     switch(rightNow.get(Calendar.MINUTE))
                    {
                        case 0:
                             clockL.setText((rightNow.get(Calendar.HOUR_OF_DAY)-12)+":00");break;
                        case 1:
                             clockL.setText((rightNow.get(Calendar.HOUR_OF_DAY)-12)+":01");break;
                        case 2:
                             clockL.setText((rightNow.get(Calendar.HOUR_OF_DAY)-12)+":02");break;
                        case 3:
                             clockL.setText((rightNow.get(Calendar.HOUR_OF_DAY)-12)+":03");break;
                        case 4:
                             clockL.setText((rightNow.get(Calendar.HOUR_OF_DAY)-12)+":04");break;
                        case 5:
                             clockL.setText((rightNow.get(Calendar.HOUR_OF_DAY)-12)+":05");break;
                        case 6:
                             clockL.setText((rightNow.get(Calendar.HOUR_OF_DAY)-12)+":06");break;
                        case 7:
                             clockL.setText((rightNow.get(Calendar.HOUR_OF_DAY)-12)+":07");break;
                        case 8:
                             clockL.setText((rightNow.get(Calendar.HOUR_OF_DAY)-12)+":08");break;
                        case 9:
                             clockL.setText((rightNow.get(Calendar.HOUR_OF_DAY)-12)+":09");break;
                        default:
                              clockL.setText((rightNow.get(Calendar.HOUR_OF_DAY)-12)+":"+rightNow.get(Calendar.MINUTE));break;
                    }
                }
                else if(rightNow.get(Calendar.HOUR_OF_DAY)==0)
                {
                     switch(rightNow.get(Calendar.MINUTE))
                    {
                        case 0:
                             clockL.setText("23:00");break;
                        case 1:
                             clockL.setText("12:01");break;
                        case 2:
                             clockL.setText("12:02");break;
                        case 3:
                             clockL.setText("12:03");break;
                        case 4:
                             clockL.setText("12:04");break;
                        case 5:
                             clockL.setText("12+:05");break;
                        case 6:
                            clockL.setText("12+:06");break;
                        case 7:
                            clockL.setText("12+:07");break;
                        case 8:
                             clockL.setText("12+:08");break;
                       case 9:
                             clockL.setText("12+:09");break;
                         default:
                              clockL.setText("12:"+rightNow.get(Calendar.MINUTE));break;
                    }
                }
                else
                {
                    switch(rightNow.get(Calendar.MINUTE))
                    {
                        case 0:
                             clockL.setText(rightNow.get(Calendar.HOUR_OF_DAY)+":00");break;
                        case 1:
                             clockL.setText(rightNow.get(Calendar.HOUR_OF_DAY)+":01");break;
                        case 2:
                             clockL.setText(rightNow.get(Calendar.HOUR_OF_DAY)+":02");break;
                        case 3:
                             clockL.setText(rightNow.get(Calendar.HOUR_OF_DAY)+":03");break;
                        case 4:
                             clockL.setText(rightNow.get(Calendar.HOUR_OF_DAY)+":04");break;
                        case 5:
                             clockL.setText(rightNow.get(Calendar.HOUR_OF_DAY)+":05");break;
                        case 6:
                             clockL.setText(rightNow.get(Calendar.HOUR_OF_DAY)+":06");break;
                        case 7:
                             clockL.setText(rightNow.get(Calendar.HOUR_OF_DAY)+":07");break;
                        case 8:
                             clockL.setText(rightNow.get(Calendar.HOUR_OF_DAY)+":08");break;
                        case 9:
                             clockL.setText(rightNow.get(Calendar.HOUR_OF_DAY)+":09");break;
                        default:
                              clockL.setText(rightNow.get(Calendar.HOUR_OF_DAY)+":"+rightNow.get(Calendar.MINUTE));break;
                    }
                }
            
                updateWeather();
                
                try {updateThread.sleep(15000);} 
                catch (InterruptedException e) {e.printStackTrace();}
            
            }
            else
            {
                  try {updateThread.sleep(1000);} 
                  catch (InterruptedException e) {e.printStackTrace();}
            }
        }
    }
		
    static public String getString(byte[] inBytes) 
    {
        tString="";
        for(int i=0;i<inBytes.length;i++)
        {
                if(inBytes[i]==0)
                        break;
                else
                        tString+=(char)inBytes[i];
        }
        return tString;
    }

      static public void updateWeather()
      {
          try {stream=url.openStream();} 
          catch (IOException e1) 
          {
              weatherL.setText("not available");
              return;
          }
          try 
          {
                    stream.read(bytes1);
                    stream.read(bytes2);
           } 
          catch (IOException e1) 
          {
              weatherL.setText("not available");
              return;
          }

          tString=getString(bytes1)+getString(bytes2);
          codeStart=tString.indexOf("code=")+6;
          tempStart=tString.indexOf("temp=")+6;
          codeEnd=tString.indexOf("\"",codeStart);
          tempEnd=tString.indexOf("\"",tempStart);

          code=tString.substring(codeStart, codeEnd);
          temp=tString.substring(tempStart, tempEnd);
          tempL.setText(temp+" degrees");

          if(code.equals("0"))	
                  weatherL.setText("tornado");
          else if(code.equals("1"))
                  weatherL.setText("tropical storm");
          else if(code.equals("2"))
                  weatherL.setText("hurricane");
          else if(code.equals("3"))
                  weatherL.setText("severe thunderstorms");
          else if(code.equals("4"))
                  weatherL.setText("thunderstorms");
          else if(code.equals("5"))
                  weatherL.setText("mixed rain and snow");
          else if(code.equals("6"))
                  weatherL.setText("mixed rain and sleet");
          else if(code.equals("7"))
                  weatherL.setText("mixed snow and sleet");
          else if(code.equals("8"))
                  weatherL.setText("freezing drizzle");
          else if(code.equals("9"))
                  weatherL.setText("drizzle");
          else if(code.equals("10"))
                  weatherL.setText("freezing rain");

          else if(code.equals("11"))
                  weatherL.setText("showers");
          else if(code.equals("12"))
                  weatherL.setText("showers");
          else if(code.equals("13"))
                  weatherL.setText("snow flurries");
          else if(code.equals("14"))
                  weatherL.setText("light snow showers");
          else if(code.equals("15"))
                  weatherL.setText("blowing snow");
          else if(code.equals("16"))
                  weatherL.setText("snow");
          else if(code.equals("17"))
                  weatherL.setText("hail");
          else if(code.equals("18"))
                  weatherL.setText("sleet");
          else if(code.equals("19"))
                  weatherL.setText("dust");
          else if(code.equals("20"))
                  weatherL.setText("foggy");

          else if(code.equals("21"))
                  weatherL.setText("haze");
          else if(code.equals("22"))
                  weatherL.setText("smokey");
          else if(code.equals("23"))
                  weatherL.setText("blustery");
          else if(code.equals("24"))
                  weatherL.setText("windy");
          else if(code.equals("25"))
                  weatherL.setText("cold");
          else if(code.equals("26"))
                  weatherL.setText("cloudy");
          else if(code.equals("27"))
                  weatherL.setText("mostly cloudy");
          else if(code.equals("28"))
                  weatherL.setText("mostly cloudy");
          else if(code.equals("29"))
                  weatherL.setText("partly cloudy");
          else if(code.equals("30"))
                  weatherL.setText("partly cloudy");

          else if(code.equals("31"))
                  weatherL.setText("clear");
          else if(code.equals("32"))
                  weatherL.setText("sunny");
          else if(code.equals("33"))
                  weatherL.setText("fair");
          else if(code.equals("34"))
                  weatherL.setText("fair");
          else if(code.equals("35"))
                  weatherL.setText("mixed rain and hail");
          else if(code.equals("36"))
                  weatherL.setText("hot");
          else if(code.equals("37"))
                  weatherL.setText("isolated thunderstorms");
          else if(code.equals("38"))
                  weatherL.setText("scattered thunderstorms");
          else if(code.equals("39"))
                  weatherL.setText("scattered thunderstorms");
          else if(code.equals("40"))
                  weatherL.setText("scattered showers");

          else if(code.equals("41"))
                  weatherL.setText("heavy snow");
          else if(code.equals("42"))
                  weatherL.setText("scattered snow showers");
          else if(code.equals("43"))
                  weatherL.setText("heavy snow");
          else if(code.equals("44"))
                  weatherL.setText("partly cloudy");
          else if(code.equals("45"))
                  weatherL.setText("thundershowers");
          else if(code.equals("46"))
                  weatherL.setText("snow showers");
          else if(code.equals("47"))
                  weatherL.setText("isolated thundershowers");

          else if(code.equals("3200"))
                  weatherL.setText("not available");			    
      }
}
